Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 977)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 978)
@@ -4,4 +4,5 @@
 ! Current revisions:
 ! -----------------
+! +z0h_av
 !
 ! Former revisions:
@@ -284,4 +285,11 @@
              ENDDO
 
+          CASE ( 'z0h*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d )
+                ENDDO
+             ENDDO
+
           CASE DEFAULT
 !
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 977)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 978)
@@ -4,5 +4,8 @@
 ! Current revisions:
 ! -----------------
-!
+! Neumann boudnary conditions are added at the inflow boundary for the SGS-TKE.
+! Outflow boundary conditions for the velocity components can be set to Neumann
+! conditions or to radiation conditions with a horizontal averaged phase
+! velocity. 
 ! 
 !  
@@ -190,5 +193,4 @@
           q_p(nzt+1,:,:) = q_p(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
 
-
        ENDIF
 
@@ -198,8 +200,15 @@
 !--    Since in prognostic_equations (cache optimized version) these levels are
 !--    handled as a prognostic level, boundary values have to be restored here.
+!--    For the SGS-TKE, Neumann boundary conditions are used at the inflow.
        IF ( inflow_s )  THEN
           v_p(:,nys,:) = v_p(:,nys-1,:)
+          IF ( .NOT. constant_diffusion ) e_p(:,nys-1,:) = e_p(:,nys,:)
+       ELSEIF ( inflow_n )  THEN
+          IF ( .NOT. constant_diffusion ) e_p(:,nyn+1,:) = e_p(:,nyn,:)
        ELSEIF ( inflow_l ) THEN
           u_p(:,:,nxl) = u_p(:,:,nxl-1)
+          IF ( .NOT. constant_diffusion ) e_p(:,:,nxl-1) = e_p(:,:,nxl)
+       ELSEIF ( inflow_r )  THEN
+          IF ( .NOT. constant_diffusion ) e_p(:,:,nxr+1) = e_p(:,:,nxr)
        ENDIF
 
@@ -227,22 +236,35 @@
 
 !
-!-- Radiation boundary condition for the velocities at the respective outflow
+!-- Neumann or Radiation boundary condition for the velocities at the 
+!-- respective outflow
     IF ( outflow_s )  THEN
 
-       c_max = dy / dt_3d
-
-       DO i = nxlg, nxrg
+       IF ( bc_ns_dirneu )  THEN
+          u(:,-1,:) = u(:,0,:)
+          v(:,0,:)  = v(:,1,:)
+          w(:,-1,:) = w(:,0,:)          
+       ELSEIF ( bc_ns_dirrad )  THEN
+
+          c_max = dy / dt_3d
+
+          c_u_m_l = 0.0 
+          c_v_m_l = 0.0
+          c_w_m_l = 0.0
+
+          c_u_m = 0.0 
+          c_v_m = 0.0
+          c_w_m = 0.0
+
+!
+!--       Calculate the phase speeds for u,v, and w, first local and then 
+!--       average parallel along the outflow boundary.  
           DO k = nzb+1, nzt+1
-
-!
-!--          Calculate the phase speeds for u,v, and w. In case of using a
-!--          Runge-Kutta scheme, do this for the first substep only and then
-!--          reuse this values for the further substeps.
-             IF ( intermediate_timestep_count == 1 )  THEN
+             DO i = nxl, nxr
 
                 denom = u_m_s(k,0,i) - u_m_s(k,1,i)
 
                 IF ( denom /= 0.0 )  THEN
-                   c_u(k,i) = -c_max * ( u(k,0,i) - u_m_s(k,0,i) ) / denom
+                   c_u(k,i) = -c_max * ( u(k,0,i) - u_m_s(k,0,i) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_u(k,i) < 0.0 )  THEN
                       c_u(k,i) = 0.0
@@ -257,5 +279,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_v(k,i) = -c_max * ( v(k,1,i) - v_m_s(k,1,i) ) / denom
+                   c_v(k,i) = -c_max * ( v(k,1,i) - v_m_s(k,1,i) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_v(k,i) < 0.0 )  THEN
                       c_v(k,i) = 0.0
@@ -270,5 +293,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_w(k,i) = -c_max * ( w(k,0,i) - w_m_s(k,0,i) ) / denom
+                   c_w(k,i) = -c_max * ( w(k,0,i) - w_m_s(k,0,i) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_w(k,i) < 0.0 )  THEN
                       c_w(k,i) = 0.0
@@ -280,47 +304,77 @@
                 ENDIF
 
-!
-!--             Save old timelevels for the next timestep
-                u_m_s(k,:,i) = u(k,0:1,i)
-                v_m_s(k,:,i) = v(k,1:2,i)
-                w_m_s(k,:,i) = w(k,0:1,i)
-
-             ENDIF
-
-!
-!--          Calculate the new velocities
-             u_p(k,-1,i) = u(k,-1,i) - dt_3d * tsc(2) * c_u(k,i) * &
+                c_u_m_l(k) = c_u_m_l(k) + c_u(k,i)
+                c_v_m_l(k) = c_v_m_l(k) + c_v(k,i)
+                c_w_m_l(k) = c_w_m_l(k) + c_w(k,i)
+
+             ENDDO
+          ENDDO
+
+#if defined( __parallel )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_u_m_l(nzb+1), c_u_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_v_m_l(nzb+1), c_v_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )  
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_w_m_l(nzb+1), c_w_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )  
+#else
+          c_u_m = c_u_m_l
+          c_v_m = c_v_m_l
+          c_w_m = c_w_m_l
+#endif
+
+          c_u_m = c_u_m / (nx+1)
+          c_v_m = c_v_m / (nx+1)
+          c_w_m = c_w_m / (nx+1)
+
+!
+!--       Save old timelevels for the next timestep
+          IF ( intermediate_timestep_count == 1 )  THEN
+             u_m_s(:,:,:) = u(:,0:1,:)
+             v_m_s(:,:,:) = v(:,1:2,:)
+             w_m_s(:,:,:) = w(:,0:1,:)
+          ENDIF
+
+!
+!--       Calculate the new velocities
+          DO k = nzb+1, nzt+1 
+             DO i = nxlg, nxrg
+                u_p(k,-1,i) = u(k,-1,i) - dt_3d * tsc(2) * c_u_m(k) *          &
                                        ( u(k,-1,i) - u(k,0,i) ) * ddy
 
-             v_p(k,0,i)  = v(k,0,i)  - dt_3d * tsc(2) * c_v(k,i) * &
+                v_p(k,0,i)  = v(k,0,i)  - dt_3d * tsc(2) * c_v_m(k) *          &
                                        ( v(k,0,i) - v(k,1,i) ) * ddy
 
-             w_p(k,-1,i) = w(k,-1,i) - dt_3d * tsc(2) * c_w(k,i) * &
+                w_p(k,-1,i) = w(k,-1,i) - dt_3d * tsc(2) * c_w_m(k) *          &
                                        ( w(k,-1,i) - w(k,0,i) ) * ddy
-
-          ENDDO
-       ENDDO
-
-!
-!--    Bottom boundary at the outflow
-       IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,-1,:) = 0.0 
-          v_p(nzb,0,:)  = 0.0  
-       ELSE                    
-          u_p(nzb,-1,:) =  u_p(nzb+1,-1,:)
-          v_p(nzb,0,:)  =  v_p(nzb+1,0,:)
-       ENDIF
-       w_p(nzb,-1,:) = 0.0
-
-!
-!--    Top boundary at the outflow
-       IF ( ibc_uv_t == 0 )  THEN
-          u_p(nzt+1,-1,:) = u_init(nzt+1)
-          v_p(nzt+1,0,:)  = v_init(nzt+1)
-       ELSE
-          u_p(nzt+1,-1,:) = u(nzt,-1,:)
-          v_p(nzt+1,0,:)  = v(nzt,0,:)
-       ENDIF
-       w_p(nzt:nzt+1,-1,:) = 0.0
+             ENDDO
+          ENDDO
+
+!
+!--       Bottom boundary at the outflow
+          IF ( ibc_uv_b == 0 )  THEN
+             u_p(nzb,-1,:) = 0.0 
+             v_p(nzb,0,:)  = 0.0  
+          ELSE                    
+             u_p(nzb,-1,:) =  u_p(nzb+1,-1,:)
+             v_p(nzb,0,:)  =  v_p(nzb+1,0,:)
+          ENDIF
+          w_p(nzb,-1,:) = 0.0
+
+!
+!--       Top boundary at the outflow
+          IF ( ibc_uv_t == 0 )  THEN
+             u_p(nzt+1,-1,:) = u_init(nzt+1)
+             v_p(nzt+1,0,:)  = v_init(nzt+1)
+          ELSE
+             u_p(nzt+1,-1,:) = u(nzt,-1,:)
+             v_p(nzt+1,0,:)  = v(nzt,0,:)
+          ENDIF
+          w_p(nzt:nzt+1,-1,:) = 0.0
+
+       ENDIF
 
     ENDIF
@@ -328,19 +382,31 @@
     IF ( outflow_n )  THEN
 
-       c_max = dy / dt_3d
-
-       DO i = nxlg, nxrg
+       IF ( bc_ns_neudir )  THEN
+          u(:,ny+1,:) = u(:,ny,:)
+          v(:,ny+1,:) = v(:,ny,:)
+          w(:,ny+1,:) = w(:,ny,:)          
+       ELSEIF ( bc_ns_dirrad )  THEN
+
+          c_max = dy / dt_3d
+
+          c_u_m_l = 0.0 
+          c_v_m_l = 0.0
+          c_w_m_l = 0.0
+
+          c_u_m = 0.0 
+          c_v_m = 0.0
+          c_w_m = 0.0
+
+!
+!--       Calculate the phase speeds for u,v, and w, first local and then 
+!--       average parallel along the outflow boundary.  
           DO k = nzb+1, nzt+1
-
-!
-!--          Calculate the phase speeds for u,v, and w. In case of using a
-!--          Runge-Kutta scheme, do this for the first substep only and then
-!--          reuse this values for the further substeps.
-             IF ( intermediate_timestep_count == 1 )  THEN
+             DO i = nxl, nxr
 
                 denom = u_m_n(k,ny,i) - u_m_n(k,ny-1,i)
 
                 IF ( denom /= 0.0 )  THEN
-                   c_u(k,i) = -c_max * ( u(k,ny,i) - u_m_n(k,ny,i) ) / denom
+                   c_u(k,i) = -c_max * ( u(k,ny,i) - u_m_n(k,ny,i) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_u(k,i) < 0.0 )  THEN
                       c_u(k,i) = 0.0
@@ -355,5 +421,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_v(k,i) = -c_max * ( v(k,ny,i) - v_m_n(k,ny,i) ) / denom
+                   c_v(k,i) = -c_max * ( v(k,ny,i) - v_m_n(k,ny,i) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_v(k,i) < 0.0 )  THEN
                       c_v(k,i) = 0.0
@@ -368,5 +435,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_w(k,i) = -c_max * ( w(k,ny,i) - w_m_n(k,ny,i) ) / denom
+                   c_w(k,i) = -c_max * ( w(k,ny,i) - w_m_n(k,ny,i) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_w(k,i) < 0.0 )  THEN
                       c_w(k,i) = 0.0
@@ -378,47 +446,77 @@
                 ENDIF
 
-!
-!--             Swap timelevels for the next timestep
-                u_m_n(k,:,i) = u(k,ny-1:ny,i)
-                v_m_n(k,:,i) = v(k,ny-1:ny,i)
-                w_m_n(k,:,i) = w(k,ny-1:ny,i)
-
-             ENDIF
-
-!
-!--          Calculate the new velocities
-             u_p(k,ny+1,i) = u(k,ny+1,i) - dt_3d * tsc(2) * c_u(k,i) * &
-                                           ( u(k,ny+1,i) - u(k,ny,i) ) * ddy
-
-             v_p(k,ny+1,i) = v(k,ny+1,i) - dt_3d * tsc(2) * c_v(k,i) * &
-                                           ( v(k,ny+1,i) - v(k,ny,i) ) * ddy
-
-             w_p(k,ny+1,i) = w(k,ny+1,i) - dt_3d * tsc(2) * c_w(k,i) * &
-                                           ( w(k,ny+1,i) - w(k,ny,i) ) * ddy
-
-          ENDDO
-       ENDDO
-
-!
-!--    Bottom boundary at the outflow
-       IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,ny+1,:) = 0.0 
-          v_p(nzb,ny+1,:) = 0.0   
-       ELSE                    
-          u_p(nzb,ny+1,:) =  u_p(nzb+1,ny+1,:)
-          v_p(nzb,ny+1,:) =  v_p(nzb+1,ny+1,:)
-       ENDIF
-       w_p(nzb,ny+1,:) = 0.0
-
-!
-!--    Top boundary at the outflow
-       IF ( ibc_uv_t == 0 )  THEN
-          u_p(nzt+1,ny+1,:) = u_init(nzt+1)
-          v_p(nzt+1,ny+1,:) = v_init(nzt+1)
-       ELSE
-          u_p(nzt+1,ny+1,:) = u_p(nzt,nyn+1,:)
-          v_p(nzt+1,ny+1,:) = v_p(nzt,nyn+1,:)
-       ENDIF
-       w_p(nzt:nzt+1,ny+1,:) = 0.0
+                c_u_m_l(k) = c_u_m_l(k) + c_u(k,i)
+                c_v_m_l(k) = c_v_m_l(k) + c_v(k,i)
+                c_w_m_l(k) = c_w_m_l(k) + c_w(k,i)
+
+             ENDDO
+          ENDDO
+
+#if defined( __parallel )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_u_m_l(nzb+1), c_u_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_v_m_l(nzb+1), c_v_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )  
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dx, ierr )
+          CALL MPI_ALLREDUCE( c_w_m_l(nzb+1), c_w_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dx, ierr )  
+#else
+          c_u_m = c_u_m_l
+          c_v_m = c_v_m_l
+          c_w_m = c_w_m_l
+#endif
+
+          c_u_m = c_u_m / (nx+1)
+          c_v_m = c_v_m / (nx+1)
+          c_w_m = c_w_m / (nx+1)
+
+!
+!--       Save old timelevels for the next timestep
+          IF ( intermediate_timestep_count == 1 )  THEN
+                u_m_n(:,:,:) = u(:,ny-1:ny,:)
+                v_m_n(:,:,:) = v(:,ny-1:ny,:)
+                w_m_n(:,:,:) = w(:,ny-1:ny,:)
+          ENDIF
+
+!
+!--       Calculate the new velocities
+          DO k = nzb+1, nzt+1 
+             DO i = nxlg, nxrg
+                u_p(k,ny+1,i) = u(k,ny+1,i) - dt_3d * tsc(2) * c_u_m(k) *      &
+                                       ( u(k,ny+1,i) - u(k,ny,i) ) * ddy
+
+                v_p(k,ny+1,i) = v(k,ny+1,i)  - dt_3d * tsc(2) * c_v_m(k) *     &
+                                       ( v(k,ny+1,i) - v(k,ny,i) ) * ddy
+
+                w_p(k,ny+1,i) = w(k,ny+1,i) - dt_3d * tsc(2) * c_w_m(k) *      &
+                                       ( w(k,ny+1,i) - w(k,ny,i) ) * ddy
+             ENDDO
+          ENDDO
+
+!
+!--       Bottom boundary at the outflow
+          IF ( ibc_uv_b == 0 )  THEN
+             u_p(nzb,ny+1,:) = 0.0 
+             v_p(nzb,ny+1,:) = 0.0   
+          ELSE                    
+             u_p(nzb,ny+1,:) =  u_p(nzb+1,ny+1,:)
+             v_p(nzb,ny+1,:) =  v_p(nzb+1,ny+1,:)
+          ENDIF
+          w_p(nzb,ny+1,:) = 0.0
+
+!
+!--       Top boundary at the outflow
+          IF ( ibc_uv_t == 0 )  THEN
+             u_p(nzt+1,ny+1,:) = u_init(nzt+1)
+             v_p(nzt+1,ny+1,:) = v_init(nzt+1)
+          ELSE
+             u_p(nzt+1,ny+1,:) = u_p(nzt,nyn+1,:)
+             v_p(nzt+1,ny+1,:) = v_p(nzt,nyn+1,:)
+          ENDIF
+          w_p(nzt:nzt+1,ny+1,:) = 0.0
+
+       ENDIF
 
     ENDIF
@@ -426,19 +524,31 @@
     IF ( outflow_l )  THEN
 
-       c_max = dx / dt_3d
-
-       DO j = nysg, nyng
+       IF ( bc_lr_neudir )  THEN
+          u(:,:,-1) = u(:,:,0)
+          v(:,:,0)  = v(:,:,1)
+          w(:,:,-1) = w(:,:,0)          
+       ELSEIF ( bc_ns_dirrad )  THEN
+
+          c_max = dx / dt_3d
+
+          c_u_m_l = 0.0 
+          c_v_m_l = 0.0
+          c_w_m_l = 0.0
+
+          c_u_m = 0.0 
+          c_v_m = 0.0
+          c_w_m = 0.0
+
+!
+!--       Calculate the phase speeds for u,v, and w, first local and then 
+!--       average parallel along the outflow boundary.  
           DO k = nzb+1, nzt+1
-
-!
-!--          Calculate the phase speeds for u,v, and w. In case of using a
-!--          Runge-Kutta scheme, do this for the first substep only and then
-!--          reuse this values for the further substeps.
-             IF ( intermediate_timestep_count == 1 )  THEN
+             DO j = nys, nyn
 
                 denom = u_m_l(k,j,1) - u_m_l(k,j,2)
 
                 IF ( denom /= 0.0 )  THEN
-                   c_u(k,j) = -c_max * ( u(k,j,1) - u_m_l(k,j,1) ) / denom
+                   c_u(k,j) = -c_max * ( u(k,j,1) - u_m_l(k,j,1) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_u(k,j) < 0.0 )  THEN
                       c_u(k,j) = 0.0
@@ -453,5 +563,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_v(k,j) = -c_max * ( v(k,j,0) - v_m_l(k,j,0) ) / denom
+                   c_v(k,j) = -c_max * ( v(k,j,0) - v_m_l(k,j,0) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_v(k,j) < 0.0 )  THEN
                       c_v(k,j) = 0.0
@@ -466,5 +577,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_w(k,j) = -c_max * ( w(k,j,0) - w_m_l(k,j,0) ) / denom
+                   c_w(k,j) = -c_max * ( w(k,j,0) - w_m_l(k,j,0) )             &
+                              / ( denom * tsc(2) )
                    IF ( c_w(k,j) < 0.0 )  THEN
                       c_w(k,j) = 0.0
@@ -476,47 +588,77 @@
                 ENDIF
 
-!
-!--             Swap timelevels for the next timestep
-                u_m_l(k,j,:) = u(k,j,1:2)
-                v_m_l(k,j,:) = v(k,j,0:1)
-                w_m_l(k,j,:) = w(k,j,0:1)
-
-             ENDIF
-
-!
-!--          Calculate the new velocities
-             u_p(k,j,0)  = u(k,j,0)  - dt_3d * tsc(2) * c_u(k,j) * &
+                c_u_m_l(k) = c_u_m_l(k) + c_u(k,j)
+                c_v_m_l(k) = c_v_m_l(k) + c_v(k,j)
+                c_w_m_l(k) = c_w_m_l(k) + c_w(k,j)
+
+             ENDDO
+          ENDDO
+
+#if defined( __parallel )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_u_m_l(nzb+1), c_u_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_v_m_l(nzb+1), c_v_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )  
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_w_m_l(nzb+1), c_w_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )  
+#else
+          c_u_m = c_u_m_l
+          c_v_m = c_v_m_l
+          c_w_m = c_w_m_l
+#endif
+
+          c_u_m = c_u_m / (ny+1)
+          c_v_m = c_v_m / (ny+1)
+          c_w_m = c_w_m / (ny+1)
+
+!
+!--       Save old timelevels for the next timestep
+          IF ( intermediate_timestep_count == 1 )  THEN
+                u_m_l(:,:,:) = u(:,:,1:2)
+                v_m_l(:,:,:) = v(:,:,0:1)
+                w_m_l(:,:,:) = w(:,:,0:1)
+          ENDIF
+
+!
+!--       Calculate the new velocities
+          DO k = nzb+1, nzt+1 
+             DO i = nxlg, nxrg
+                u_p(k,j,0) = u(k,j,0) - dt_3d * tsc(2) * c_u_m(k) *            &
                                        ( u(k,j,0) - u(k,j,1) ) * ddx
 
-             v_p(k,j,-1) = v(k,j,-1) - dt_3d * tsc(2) * c_v(k,j) * &
+                v_p(k,j,-1) = v(k,j,-1) - dt_3d * tsc(2) * c_v_m(k) *          &
                                        ( v(k,j,-1) - v(k,j,0) ) * ddx
 
-             w_p(k,j,-1) = w(k,j,-1) - dt_3d * tsc(2) * c_w(k,j) * &
+                w_p(k,j,-1) = w(k,j,-1) - dt_3d * tsc(2) * c_w_m(k) *          &
                                        ( w(k,j,-1) - w(k,j,0) ) * ddx
-
-          ENDDO
-       ENDDO
-
-!
-!--    Bottom boundary at the outflow
-       IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,:,0)  = 0.0 
-          v_p(nzb,:,-1) = 0.0
-       ELSE                    
-          u_p(nzb,:,0)  =  u_p(nzb+1,:,0)
-          v_p(nzb,:,-1) =  v_p(nzb+1,:,-1)
-       ENDIF
-       w_p(nzb,:,-1) = 0.0
-
-!
-!--    Top boundary at the outflow
-       IF ( ibc_uv_t == 0 )  THEN
-          u_p(nzt+1,:,-1) = u_init(nzt+1)
-          v_p(nzt+1,:,-1) = v_init(nzt+1)
-       ELSE
-          u_p(nzt+1,:,-1) = u_p(nzt,:,-1)
-          v_p(nzt+1,:,-1) = v_p(nzt,:,-1)
-       ENDIF
-       w_p(nzt:nzt+1,:,-1) = 0.0
+             ENDDO
+          ENDDO
+
+!
+!--       Bottom boundary at the outflow
+          IF ( ibc_uv_b == 0 )  THEN
+             u_p(nzb,:,0)  = 0.0 
+             v_p(nzb,:,-1) = 0.0
+          ELSE                    
+             u_p(nzb,:,0)  =  u_p(nzb+1,:,0)
+             v_p(nzb,:,-1) =  v_p(nzb+1,:,-1)
+          ENDIF
+          w_p(nzb,:,-1) = 0.0
+
+!
+!--       Top boundary at the outflow
+          IF ( ibc_uv_t == 0 )  THEN
+             u_p(nzt+1,:,-1) = u_init(nzt+1)
+             v_p(nzt+1,:,-1) = v_init(nzt+1)
+          ELSE
+             u_p(nzt+1,:,-1) = u_p(nzt,:,-1)
+             v_p(nzt+1,:,-1) = v_p(nzt,:,-1)
+          ENDIF
+          w_p(nzt:nzt+1,:,-1) = 0.0
+
+       ENDIF
 
     ENDIF
@@ -524,19 +666,31 @@
     IF ( outflow_r )  THEN
 
-       c_max = dx / dt_3d
-
-       DO j = nysg, nyng
+       IF ( bc_lr_dirneu )  THEN
+          u(:,:,nx+1) = u(:,:,nx)
+          v(:,:,nx+1) = v(:,:,nx)
+          w(:,:,nx+1) = w(:,:,nx)          
+       ELSEIF ( bc_ns_dirrad )  THEN
+
+          c_max = dx / dt_3d
+
+          c_u_m_l = 0.0 
+          c_v_m_l = 0.0
+          c_w_m_l = 0.0
+
+          c_u_m = 0.0 
+          c_v_m = 0.0
+          c_w_m = 0.0
+
+!
+!--       Calculate the phase speeds for u,v, and w, first local and then 
+!--       average parallel along the outflow boundary.  
           DO k = nzb+1, nzt+1
-
-!
-!--          Calculate the phase speeds for u,v, and w. In case of using a
-!--          Runge-Kutta scheme, do this for the first substep only and then
-!--          reuse this values for the further substeps.
-             IF ( intermediate_timestep_count == 1 )  THEN
+             DO j = nys, nyn
 
                 denom = u_m_r(k,j,nx) - u_m_r(k,j,nx-1)
 
                 IF ( denom /= 0.0 )  THEN
-                   c_u(k,j) = -c_max * ( u(k,j,nx) - u_m_r(k,j,nx) ) / denom
+                   c_u(k,j) = -c_max * ( u(k,j,nx) - u_m_r(k,j,nx) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_u(k,j) < 0.0 )  THEN
                       c_u(k,j) = 0.0
@@ -551,5 +705,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_v(k,j) = -c_max * ( v(k,j,nx) - v_m_r(k,j,nx) ) / denom
+                   c_v(k,j) = -c_max * ( v(k,j,nx) - v_m_r(k,j,nx) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_v(k,j) < 0.0 )  THEN
                       c_v(k,j) = 0.0
@@ -564,5 +719,6 @@
 
                 IF ( denom /= 0.0 )  THEN
-                   c_w(k,j) = -c_max * ( w(k,j,nx) - w_m_r(k,j,nx) ) / denom
+                   c_w(k,j) = -c_max * ( w(k,j,nx) - w_m_r(k,j,nx) )           &
+                              / ( denom * tsc(2) )
                    IF ( c_w(k,j) < 0.0 )  THEN
                       c_w(k,j) = 0.0
@@ -574,50 +730,79 @@
                 ENDIF
 
-!
-!--             Swap timelevels for the next timestep
-                u_m_r(k,j,:) = u(k,j,nx-1:nx)
-                v_m_r(k,j,:) = v(k,j,nx-1:nx)
-                w_m_r(k,j,:) = w(k,j,nx-1:nx)
-
-             ENDIF
-
-!
-!--          Calculate the new velocities
-             u_p(k,j,nx+1) = u(k,j,nx+1) - dt_3d * tsc(2) * c_u(k,j) * &
-                                           ( u(k,j,nx+1) - u(k,j,nx) ) * ddx
-
-             v_p(k,j,nx+1) = v(k,j,nx+1) - dt_3d * tsc(2) * c_v(k,j) * &
-                                           ( v(k,j,nx+1) - v(k,j,nx) ) * ddx
-
-             w_p(k,j,nx+1) = w(k,j,nx+1) - dt_3d * tsc(2) * c_w(k,j) * &
-                                           ( w(k,j,nx+1) - w(k,j,nx) ) * ddx
-
-          ENDDO
-       ENDDO
-
-!
-!--    Bottom boundary at the outflow
-       IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,:,nx+1) = 0.0
-          v_p(nzb,:,nx+1) = 0.0 
-       ELSE                    
-          u_p(nzb,:,nx+1) =  u_p(nzb+1,:,nx+1)
-          v_p(nzb,:,nx+1) =  v_p(nzb+1,:,nx+1)
-       ENDIF
-       w_p(nzb,:,nx+1) = 0.0
-
-!
-!--    Top boundary at the outflow
-       IF ( ibc_uv_t == 0 )  THEN
-          u_p(nzt+1,:,nx+1) = u_init(nzt+1)
-          v_p(nzt+1,:,nx+1) = v_init(nzt+1)
-       ELSE
-          u_p(nzt+1,:,nx+1) = u_p(nzt,:,nx+1)
-          v_p(nzt+1,:,nx+1) = v_p(nzt,:,nx+1)
-       ENDIF
-       w(nzt:nzt+1,:,nx+1) = 0.0
+                c_u_m_l(k) = c_u_m_l(k) + c_u(k,j)
+                c_v_m_l(k) = c_v_m_l(k) + c_v(k,j)
+                c_w_m_l(k) = c_w_m_l(k) + c_w(k,j)
+
+             ENDDO
+          ENDDO
+
+#if defined( __parallel )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_u_m_l(nzb+1), c_u_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )   
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_v_m_l(nzb+1), c_v_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )  
+          IF ( collective_wait )  CALL MPI_BARRIER( comm1dy, ierr )
+          CALL MPI_ALLREDUCE( c_w_m_l(nzb+1), c_w_m(nzb+1), nzt-nzb, MPI_REAL, &
+                              MPI_SUM, comm1dy, ierr )  
+#else
+          c_u_m = c_u_m_l
+          c_v_m = c_v_m_l
+          c_w_m = c_w_m_l
+#endif
+
+          c_u_m = c_u_m / (ny+1)
+          c_v_m = c_v_m / (ny+1)
+          c_w_m = c_w_m / (ny+1)
+
+!
+!--       Save old timelevels for the next timestep
+          IF ( intermediate_timestep_count == 1 )  THEN
+                u_m_r(:,:,:) = u(:,:,nx-1:nx)
+                v_m_r(:,:,:) = v(:,:,nx-1:nx)
+                w_m_r(:,:,:) = w(:,:,nx-1:nx)
+          ENDIF
+
+!
+!--       Calculate the new velocities
+          DO k = nzb+1, nzt+1 
+             DO i = nxlg, nxrg
+                u_p(k,j,nx+1) = u(k,j,nx+1) - dt_3d * tsc(2) * c_u_m(k) *      &
+                                       ( u(k,j,nx+1) - u(k,j,nx) ) * ddx
+
+                v_p(k,j,nx+1) = v(k,j,nx+1) - dt_3d * tsc(2) * c_v_m(k) *      &
+                                       ( v(k,j,nx+1) - v(k,j,nx) ) * ddx
+
+                w_p(k,j,nx+1) = w(k,j,nx+1) - dt_3d * tsc(2) * c_w_m(k) *      &
+                                       ( w(k,j,nx+1) - w(k,j,nx) ) * ddx
+             ENDDO
+          ENDDO
+
+!
+!--       Bottom boundary at the outflow
+          IF ( ibc_uv_b == 0 )  THEN
+             u_p(nzb,:,nx+1) = 0.0
+             v_p(nzb,:,nx+1) = 0.0 
+          ELSE                    
+             u_p(nzb,:,nx+1) =  u_p(nzb+1,:,nx+1)
+             v_p(nzb,:,nx+1) =  v_p(nzb+1,:,nx+1)
+          ENDIF
+          w_p(nzb,:,nx+1) = 0.0
+
+!
+!--       Top boundary at the outflow
+          IF ( ibc_uv_t == 0 )  THEN
+             u_p(nzt+1,:,nx+1) = u_init(nzt+1)
+             v_p(nzt+1,:,nx+1) = v_init(nzt+1)
+          ELSE
+             u_p(nzt+1,:,nx+1) = u_p(nzt,:,nx+1)
+             v_p(nzt+1,:,nx+1) = v_p(nzt,:,nx+1)
+          ENDIF
+          w(nzt:nzt+1,:,nx+1) = 0.0
+
+       ENDIF
 
     ENDIF
 
- 
  END SUBROUTINE boundary_conds
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 977)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 978)
@@ -4,5 +4,8 @@
 ! Current revisions:
 ! -----------------
-!
+! setting of bc_lr/ns_dirneu/neudir
+! outflow damping layer removed
+! check for z0h*
+! check for pt_damping_width
 !
 ! Former revisions:
@@ -1379,5 +1382,6 @@
 !-- Lateral boundary conditions
     IF ( bc_lr /= 'cyclic'  .AND.  bc_lr /= 'dirichlet/radiation'  .AND. &
-         bc_lr /= 'radiation/dirichlet' )  THEN
+         bc_lr /= 'radiation/dirichlet' .AND. bc_lr /= 'dirichlet/neumann' &
+         .AND. bc_lr /= 'neumann/dirichlet' )  THEN
        message_string = 'unknown boundary condition: bc_lr = "' // &
                         TRIM( bc_lr ) // '"'
@@ -1385,5 +1389,6 @@
     ENDIF
     IF ( bc_ns /= 'cyclic'  .AND.  bc_ns /= 'dirichlet/radiation'  .AND. &
-         bc_ns /= 'radiation/dirichlet' )  THEN
+         bc_ns /= 'radiation/dirichlet' .AND. bc_ns /= 'dirichlet/neumann' &
+         .AND. bc_ns /= 'neumann/dirichlet' )  THEN
        message_string = 'unknown boundary condition: bc_ns = "' // &
                         TRIM( bc_ns ) // '"'
@@ -1396,7 +1401,11 @@
     IF ( bc_lr == 'dirichlet/radiation' )  bc_lr_dirrad = .TRUE.
     IF ( bc_lr == 'radiation/dirichlet' )  bc_lr_raddir = .TRUE.
+    IF ( bc_lr == 'dirichlet/neumann' )    bc_lr_dirneu = .TRUE.
+    IF ( bc_lr == 'neumann/dirichlet' )    bc_lr_neudir = .TRUE.
     IF ( bc_ns /= 'cyclic' )               bc_ns_cyc    = .FALSE.
     IF ( bc_ns == 'dirichlet/radiation' )  bc_ns_dirrad = .TRUE.
     IF ( bc_ns == 'radiation/dirichlet' )  bc_ns_raddir = .TRUE.
+    IF ( bc_ns == 'dirichlet/neumann' )    bc_ns_dirneu = .TRUE.
+    IF ( bc_ns == 'neumann/dirichlet' )    bc_ns_neudir = .TRUE.
 
 !
@@ -2659,5 +2668,5 @@
              unit = 'psu'
 
-          CASE ( 'u*', 't*', 'lwp*', 'pra*', 'prr*', 'qsws*', 'shf*', 'z0*' )
+          CASE ( 'u*', 't*', 'lwp*', 'pra*', 'prr*', 'qsws*', 'shf*', 'z0*', 'z0h*' )
              IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
                 message_string = 'illegal value for data_output: "' // &
@@ -2700,4 +2709,5 @@
              IF ( TRIM( var ) == 'u*'     )  unit = 'm/s'
              IF ( TRIM( var ) == 'z0*'    )  unit = 'm'
+             IF ( TRIM( var ) == 'z0h*'    )  unit = 'm'
 
 
@@ -2964,16 +2974,9 @@
 
 !
-!-- In case of non-cyclic lateral boundaries, set the default maximum value
-!-- for the horizontal diffusivity used within the outflow damping layer,
-!-- and check/set the width of the damping layer
+!-- In case of non-cyclic lateral boundaries and a damping layer for the
+!-- potential temperature, check the width of the damping layer
     IF ( bc_lr /= 'cyclic' ) THEN
-       IF ( km_damp_max == -1.0 )  THEN
-          km_damp_max = 0.5 * dx
-       ENDIF
-       IF ( outflow_damping_width == -1.0 )  THEN
-          outflow_damping_width = MIN( 20, nx/2 )
-       ENDIF
-       IF ( outflow_damping_width <= 0  .OR.  outflow_damping_width > nx )  THEN
-          message_string = 'outflow_damping width out of range'
+       IF ( pt_damping_width < 0.0 .OR. pt_damping_width > REAL( nx * dx ) )  THEN
+          message_string = 'pt_damping_width out of range'
           CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
        ENDIF
@@ -2981,12 +2984,6 @@
 
     IF ( bc_ns /= 'cyclic' )  THEN
-       IF ( km_damp_max == -1.0 )  THEN
-          km_damp_max = 0.5 * dy
-       ENDIF
-       IF ( outflow_damping_width == -1.0 )  THEN
-          outflow_damping_width = MIN( 20, ny/2 )
-       ENDIF
-       IF ( outflow_damping_width <= 0  .OR.  outflow_damping_width > ny )  THEN
-          message_string = 'outflow_damping width out of range'
+       IF ( pt_damping_width < 0.0 .OR. pt_damping_width > REAL( ny * dy ) )  THEN
+          message_string = 'pt_damping_width out of range'
           CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
        ENDIF
@@ -3108,15 +3105,15 @@
     ENDIF
 
-    IF ( bc_lr == 'radiation/dirichlet' )  THEN
+    IF ( bc_lr == 'radiation/dirichlet' .OR. bc_lr == 'neumann/dirichlet' )  THEN
        dist_nxr    = nx - inflow_disturbance_begin
        dist_nxl(1) = nx - inflow_disturbance_end
-    ELSEIF ( bc_lr == 'dirichlet/radiation' )  THEN
+    ELSEIF ( bc_lr == 'dirichlet/radiation' .OR. bc_lr == 'dirichlet/neumann' )  THEN
        dist_nxl    = inflow_disturbance_begin
        dist_nxr(1) = inflow_disturbance_end
     ENDIF
-    IF ( bc_ns == 'dirichlet/radiation' )  THEN
+    IF ( bc_ns == 'dirichlet/radiation' .OR. bc_ns == 'dirichlet/neumann' )  THEN
        dist_nyn    = ny - inflow_disturbance_begin
        dist_nys(1) = ny - inflow_disturbance_end
-    ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
+    ELSEIF ( bc_ns == 'radiation/dirichlet' .OR. bc_ns == 'neumann/dirichlet' )  THEN
        dist_nys    = inflow_disturbance_begin
        dist_nyn(1) = inflow_disturbance_end
@@ -3126,5 +3123,5 @@
 !-- A turbulent inflow requires Dirichlet conditions at the respective inflow
 !-- boundary (so far, a turbulent inflow is realized from the left side only)
-    IF ( turbulent_inflow  .AND.  bc_lr /= 'dirichlet/radiation' )  THEN
+    IF ( turbulent_inflow  .AND.  bc_lr /= 'dirichlet/radiation' .AND.  bc_lr /= 'dirichlet/neumann' )  THEN
        message_string = 'turbulent_inflow = .T. requires a Dirichlet ' // &
                         'condition at the inflow boundary'
